program crc64;  { Creating a raw CRC from a prg, d64, t64 file}
{A lot of code based on the Primo and TVC converter
 and checker program series. Joco, Varga Viktor, Kiss Karoly }

{Check these at:
 http://tvc.homeserver.hu
 http://primo.homeserver.hu
{Programed by Viktor Varga <viktor.varga@gmail.com>}
{The program and source is free.}

{
Which things are not implemented:
-image file checking (determining only from extension, whixch type is which
-bad fomrated image check (if a d64, or t64 has not exactly the Miha Peternel
 RFC format, it can give some bugs
-freezed tape images
-bam checking in a disk image
-USR/SEQ file checking (i dont know now, how they releated iwth the start address :)
-invalid sector numbers in a d64 directory

simplifications:
all nonascii petscii characters are URLencode
(chars under $20 and over $80 are displayed as %xxx)

}
uses dos,crt;
const
     hd : array[0..15] of char='0123456789ABCDEF';


var
      f : file;
     fo : file;
      c : char;
      s : string;
  i,j,k : integer;
      l : longint;
 casname: array[1..800] of string[32];
  cascrc: array[1..800] of longint;
    err : integer;
CVTfiles: integer;
inf,otf : string[100];
   fCRC : longint;
      b : byte;
   long : boolean;

{maybe some not more used vars are declared too :) }

function hex(x:byte):string;
begin
     hex:=hd[x shr 4]+hd[x and 15];
end;

function bcd(x:byte):byte;
begin
     if x >99 then bcd:=0;
     bcd:= ((x div 10) shl 4) or (x mod 10);
end;

procedure msg(s:string);
begin
     inc(err);
     writeln(s);
end;

function GetByte:byte;
var
   b : byte;
begin
Blockread(f,b,1);
GetByte:=b;
end;

function GetWord:word;
var
   b : byte;
   w: word;
begin
Blockread(f,b,1);
w:=b;
Blockread(f,b,1);
w:=b*256+w;
GetWord:=w;
end;

function GetString(c: byte):string;
var
   i:byte;
   s: string;
   b: byte;
begin
s:='';
for i:=1 to c do
    begin
    Blockread(f,b,1);
    s:=concat(s,chr(b));
    end;
GetString:=s;
end;

{clear nonprintable}
function ClrNP(c: byte;is:string):string;
var
   i:byte;
      s,enc: string;
   b: byte;
begin
s:='';
for i:=1 to c do
    begin
    if (ord(is[i])>127) or (ord(is[i])<32) then
    begin
         Str(ord(is[i]),enc);
         s:=concat(s,' ');
    end
    else s:=concat(s,is[i]);
    end;
ClrNP:=s;
end;

function Hexcode(c: byte;is:string):string;
var
   i:byte;
      s,enc: string;
   b: byte;
begin
s:='';
for i:=1 to c do s:=concat(s,hex(ord(is[i])));
Hexcode:=s;
end;


procedure Prgcalc(inf:string);
var
load,size : word;
rawcrc : longint;
dosfn, imagefn, heximagefn, filefn,hexfilefn:string;
i:longint;
begin
     rawcrc:=0;
     i:=0;
     {set filenames}
     dosfn:=inf;
     imagefn:=inf;
     heximagefn:=hexcode(length(inf),inf);
     filefn:=Copy(inf, 1, length(inf)-4 );
     hexfilefn:=hexcode(length(filefn),filefn);

     {search for first byte}
     seek(f,0);

     {get load address}
     load:=getword;

     {calculate crc}
     while not eof(f) do
     begin
     rawcrc:=rawcrc+getbyte;
   {  readln;
     writeln(i,' ',rawcrc);
     i:=i+1;}

     end;
     {calculate size}
     size:=filesize(f)-2;

if long then
begin
Writeln('Dos filename :  ',dosfn);
Writeln('Image name   :v ',imagefn);
Writeln('Filename     :v ',filefn);
Writeln('Load address :% ',load);
Writeln('Size         :% ',size);
Writeln('Rawcrc       :% ',rawcrc);
end
else
Writeln('"',dosfn,'","',imagefn,'","',filefn,'",',load,',',size,',',rawcrc,',"',heximagefn,'","',hexfilefn,'"');

end;


procedure T64Calc(inf:string);
var
load,size,numfiles: word;
rawcrc , offset: longint;
dosfn, imagefn, heximagefn, filefn,hexfilefn:string;
i,j:longint;
begin
     rawcrc:=0;
     {set global filenames}
     dosfn:=inf;
     seek(f,$28);
     imagefn:=getstring(23);
     heximagefn:=hexcode(23,imagefn);

     {walk trough file}
     seek(f,$24);
     numfiles:=getword;

     for i:=1 to numfiles do
     begin
          seek(f,$20+$20*i+$02);
          load:=getword;
          size:=getword-load;

          seek(f,$20+$20*i+$10);
          filefn:=getstring(16);
          hexfilefn:=hexcode(16,filefn);

          seek(f,$20+$20*i+$8);
          offset:=getword;


          seek(f,offset);

          rawcrc:=0;
          for j:=offset to (offset+size-1) do
          begin
          rawcrc:=rawcrc+getbyte;
          end;
     if long then
     begin
     Writeln('Dos filename :  ',dosfn);
     Writeln('Image name   :  ',imagefn);
     Writeln('Filename     :  ',filefn);
     Writeln('Load address :% ',load);
     Writeln('Size         :% ',size);
     Writeln('Rawcrc       :% ',rawcrc);
     end
     else
     Writeln('"',dosfn,'","',imagefn,'","',filefn,'",',load,',',size,',',rawcrc,',"',heximagefn,'","',hexfilefn,'"');

     end;

end;

procedure D64Calc(inf:string);
const track: array [1..40] of longint =
( $0000,  $1500,  $2a00,  $3f00,  $5400,  $6900,  $7e00,  $9300,  $a800,  $bd00,
  $d200,  $e700,  $fc00, $11100, $12600, $13b00, $15000, $16500, $17800, $18b00,
 $19e00, $1b100, $1c400, $1d700, $1ea00, $1fc00, $20e00, $22000, $23200, $24400,
 $25600, $26700, $27800, $28900, $29a00, $2ab00, $2bc00, $2cd00, $2de00, $2ef00);

var
load,size, numfiles: word;
rawcrc , offset: longint;
dosfn, imagefn, heximagefn, hexfilefn,filefn:string;
i,j,k:longint;
tr,se,nse,ntr,ftyp,drop,dtr,dse,ndtr,ndse,sread,fnum:integer;
first:boolean;
begin
     rawcrc:=0;
     {set global filenames}
     dosfn:=inf;

     seek(f,(track[18]+0*256+$90));
     imagefn:=getstring(16);
     heximagefn:=hexcode(16,imagefn);
     imagefn:=ClrNP(16,imagefn);

     {select first dir sector}
     tr:=18;
     se:=1;
repeat
      for fnum:=0 to 7 do

      begin
           {seek to the aktual file entry in this dir sector}
           seek(f, (track[tr]+se*256+fnum*$20));

           {if this is the first file in the dir, store
           next dir block position, else drop this datum}
           if fnum=0 then ntr:=getbyte else drop:=getbyte;
           if fnum=0 then nse:=getbyte else drop:=getbyte;

           {store file type}
           ftyp:=getbyte;

           {store file data start tr/se}
           dtr:=getbyte;
           dse:=getbyte;
           {store filename}
           filefn:=Getstring(16);
           hexfilefn:=hexcode(16,filefn);
           filefn:=ClrNP(16,filefn);


           if ftyp=$82 then
           begin
                rawcrc:=0;
                first:=true;
                size:=0;
                repeat
                      {seek to the first file data sector}
                      seek(f, (track[dtr]+dse*256));

                      {store the data of the next sector}
                      ndtr:=getbyte;
                      ndse:=getbyte;

                      {if first data block, then there will be a start address}
                      if first then
                      begin
                           load:=getword;
                           first:=false;
                      end
                      else
                      begin
                           rawcrc:=rawcrc+getbyte+getbyte;
                           inc(size);
                           inc(size);
                      end;

                      {if next data rack is null, we sould only read
                      a few bytes stored in next data sector}
                      if ndtr=0 then sread:=(ndse-4) else sread:=251;

                      for i:=0 to sread do
                      begin
                           rawcrc:=rawcrc+getbyte;
                           inc(size);
                      end;
                      dtr:=ndtr;
                      dse:=ndse;

                until ndtr=0;

                if long then
                begin
                     Writeln('Dos filename :  ',dosfn);
                     Writeln('Image name   :e ',imagefn);
                     Writeln('Filename     :e ',filefn);
                     Writeln('Load address :% ',load);
                     Writeln('Size         :% ',size);
                     Writeln('Rawcrc       :% ',rawcrc);
                end
                else
          Writeln('"',dosfn,'","',imagefn,'","',filefn,'",',load,',',size,',',rawcrc,',"',heximagefn,'","',hexfilefn,'"');
           end;
      end;

      tr:=ntr;
      se:=nse;

until ((ntr=0) and (nse=$ff));
end;

procedure Ftype(inf:string);
{select crc code, regarding from extension}
var
e :string;

begin
    E:=upcase(copy(inf,length(inf)-3,length(inf)));
    Writeln(e);
    if E='.PRG' then PrgCalc(inf);
    if E='.D64' then D64calc(inf);
    if E='.T64' then T64calc(inf);
    if (E<>'.T64') and (E<>'.D64') and (E<>'.PRG') then writeln('!Error: ',inf,' is not C64 file.');

end;


{this routine handles the joker chars in file name pattern,
 thanks to Kiss Karoly}
procedure Checkfile;
var lng:byte;
    fln:string;
    DirInfo: SearchRec;
begin
if long then lng:=2 else lng:=1;
for k:=lng to paramcount do
begin
    fln:=paramstr(k);
    inf:='';
    FindFirst(fln, Archive, DirInfo);
    while DosError = 0 do
    begin
         inf:=DirInfo.Name;
         assign(f,inf);
         {$I-}
         reset(f,1);
         {$I+}
         if IOresult<>0 then writeln(inf,' file open error. Skipped...')
         else begin
                  {seek to 1st byte of data}
                  Seek(f,0);
                  If inf<>'STDERR.TXT' then begin
                                            Ftype(inf);
                                            close(f);
                                            end
                  else close(f);
              end;
         FindNext(DirInfo);
    end;
end; {for end}
end; {procedure end}


BEGIN
assign(output,'');
Rewrite(output);
{This code needed to redirect the results to file under DOS,
sorry but i don't know how do this to be linux compatible,
thanks to Kiss Karoly}

Writeln;

CVTfiles:=0;
if paramcount > 0 then
    if paramstr(1)='-l' then long:=true else long:=false
else
    begin
    Writeln('CRC64 V1.0 - Creating a raw CRC from a .d64, .t64 or .prg file');
    writeln('USE: crc64 inputfile [inputfile] [inputfile...]');
    writeln('Parameters:');
    writeln(' -l: long detailed info, otherwise you get CSVs on screen');
    writeln(' inputfiles are CAS files');
    writeln('For example:');
    writeln(' crc64 -l sosperec.t64 bizbaz.d64');
    writeln('OR');
    writeln(' crc64 -l a*.t64');
    writeln('OR redirect output to file');
    writeln(' crc64 *.t64 >list.txt');
    writeln;
    writeln('The structure of the CSV lines is the following:');
    Writeln('1) PC file name (D64, T64, PRG)');
    Writeln('2) Image name in the file, if it is stored (D64, T64), ASCII (32-128)');
    Writeln('3) Name of the file founded in the image (see 2)');
    Writeln('4) Load address');
    Writeln('5) Size in bytes');
    Writeln('6) RawCRC - a simple sum of the databytes only');
    Writeln('The followings are needed only at D64 images because they can contain');
    Writeln('non ASCII strings, but the hexcode of the names pereserves the original name.');
    Writeln('7) Original image name converted to hex string');
    Writeln('8) Original file name converted to hex string');
    Writeln;
    halt;
    end;

Checkfile;
If CVTfiles>0 then
For i:=1 to CVTfiles do
begin
     WriteLn('File: ',CASname[i]:12,' Raw CRC: ',CAScrc[i]:8);
end;
Writeln('------------------------------------------------');
Writeln('HTTP://WWW.GB64.COM');
Writeln('HTTP://Utilbase_site_is_not_avaible.yet');
Writeln;
Writeln('Don''t forget to send us, if you have a');
Writeln('software that we have not on the website.');

close(output);
END.
